import { ApiCall, BaseConnection } from "tsrpc";
import { ReqLogin, ResLogin } from "../../shared/protocols/account/PtlLogin";
import { ILiffData } from "../../shared/protocols/define/interface";
import { ServiceType } from "../../shared/protocols/serviceProto";
import { getLiffProfile } from "../../utils";

export default async function (call: ApiCall<ReqLogin, ResLogin>) {
	// Error
	if (!call.req.token) {
		call.error("Name is empty");
		return;
	}

	// Success
	const { token } = call.req;
	const conn: BaseConnection<ServiceType> = call.conn;
	const profile: ILiffData = await getLiffProfile(token);
	console.log(`name: ${profile.displayName} is Login`);
	conn.userId = profile.userId ?? "";
	conn.displayName = profile.displayName ?? "";
	conn.statusMessage = profile.statusMessage ?? "";
	conn.pictureUrl = profile.pictureUrl ?? "";
	const data: ILiffData = { ...conn };
	call.succ(data);
}