import { ApiCall, BaseConnection } from "tsrpc";
import Room from "../../component/Room/Room";
import { ReqJoin, ResJoin } from "../../shared/protocols/room/PtlJoin";
import { ServiceType } from "../../shared/protocols/serviceProto";
import { sleep } from "../../utils";

export default async function (call: ApiCall<ReqJoin, ResJoin>) {
	const { roomId } = call.req;
	const conn: BaseConnection<ServiceType> = call.conn;
	const room: Room = Room.GetRoom(roomId);
	if (room) {
		if (room.ConnCount() >= 2) {
			call.error("房間已滿");
			return;
		}
		const type: number = room.Join(conn);
		conn.Room = room;
		call.succ([room.ConnCount(), type]);

		if (room.ConnCount() >= 2) {
			await sleep(100);
			room.GotoGame();
		}
	} else {
		call.error("roomId 錯誤");
	}
}