import { ApiCall, BaseConnection } from "tsrpc";
import Room from "../../component/Room/Room";
import { ReqSendAns, ResSendAns } from "../../shared/protocols/room/PtlSendAns";
import { ServiceType } from "../../shared/protocols/serviceProto";

export default async function (call: ApiCall<ReqSendAns, ResSendAns>) {
	const { answer } = call.req;
	const conn: BaseConnection<ServiceType> = call.conn;
	const room: Room = conn.Room;
	const data: boolean = room.SendAns(conn, answer);
	call.succ(data);
}