import axios from "axios";
import { ILiffData } from "../shared/protocols/define/interface";

export function sleep(ms: any): Promise<any> {
	return new Promise((resolve) => setTimeout(resolve, ms));
}

export function getArray(count: number): number[] {
	const array: number[] = [];
	for (let i: number = 0; i < count; i++) {
		array.push(i);
	}
	return array;
}

export async function getLiffProfile(token: string): Promise<ILiffData> {
	let config = {
		method: 'get',
		maxBodyLength: Infinity,
		url: 'https://api.line.me/v2/profile',
		headers: {
			'Authorization': 'Bearer ' + token
		}
	};

	let resp: ILiffData;
	axios.request(config)
		.then((response) => {
			resp = response.data;
		})
		.catch((error) => {
			resp = null;
		});

	while (resp === undefined) {
		await sleep(100);
	}
	return resp;
}